#include <LiquidCrystal_I2C.h>
#include <RTClib.h>

RTC_DS3231 rtc;
LiquidCrystal_I2C lcd(0x27, 16, 2);

void setup () {
  rtc.begin();
  
  if (rtc.lostPower()) {
    rtc.adjust(DateTime(F(__DATE__), F(__TIME__)));
  }

  lcd.init();
  lcd.backlight();
  lcd.clear();
}

void loop () {
  DateTime now = rtc.now();
  printDateTime(now);
  delay(1000);
}

void printDateTime(DateTime dt) {
  char dateBuffer[] = "   DD/MM/YYYY   ";
  char timeBuffer[] = "    hh:mm:ss    ";

  lcd.setCursor(0, 0);
  lcd.print(dt.toString(dateBuffer));
  lcd.setCursor(0, 1);
  lcd.print(dt.toString(timeBuffer));
}
